# ESTKme-RED Smart Card Reader Firmware Upgrade Notes

## Automatic Firmware Upgrade

1. Ensure there is a card in the ESTKme-RED.
2. Ensure the ESTKme-RED is connected to the computer.
3. Run the following program:
    1. For Windows, run `dfu.bat`.
    2. For macOS, run `dfu.command`.
    3. For Linux, run `dfu.linux.sh`.
4. The ESTKme-RED will light up BLUE, GREEN, and RED indicators in sequence,
   indicating that it has entered firmware update mode.
5. When "Please re-plug ESTKme-RED" is displayed, re-plug the ESTKme-RED to use it normally.

## Manual Firmware Upgrade

If after attempting the "Automatic Firmware Upgrade", you do not see the ESTKme-RED light up BLUE, GREEN, and RED
indicators in sequence, it means the ESTKme-RED has not entered firmware update mode.

You can proceed as follows:

1. Follow the method shown in <https://imgur.com/a/mWkndSY> to short-circuit and keep it connected to the computer.
2. The ESTKme-RED will light up BLUE, GREEN, and RED indicators in sequence.
3. Follow the "Automatic Firmware Update" instructions again and run the corresponding procedure.

## For macOS Users

Due to macOS security mechanisms, please read <https://support.apple.com/en-hk/guide/mac-help/mh40616/mac> and follow
the instructions before running.
